/* 1. 动态设置内容居中 */
/* 1.获取所有需要操作的元素
2.获取屏幕的宽度
3.获取一个图片元素容器的宽度
4.动态计算页面横向最多可放置的图片数量
5.动态设置样式，让内容左右居中 
*/

function waterFlow(){
    /* 获取父级容器 */
    var parentContainer = document.getElementById("container");
    /* 获取子元素 */
    var allChild =document.getElementsByClassName("box");
    /* 获取屏幕的宽度 */
    var screenWidth = document.documentElement.clientWidth;
    /* 获取一个图片容器的宽度——offsetWidt获取一个元素的宽度 */
    var childwidth = allChild[0].offsetWidth;
    /* 计算屏幕水平方向最多能拜访的图片个数 取整 再减1 预留出一张图片的位置做空白部分*/
    /* console.log(screenWidth / childwidth); */
    var rowNum =Math.floor(screenWidth / childwidth) -1;
    /* 让页面左右居中——利用css特性 */
    parentContainer.style.cssText = "width:" + rowNum * childwidth + "px;margin:0 auto;";

}
/* 要执行这个函数才会生效 ——要图片资源全部加载完成后再渲染dom*/
window.onload = function(){
    waterFlow();
}


/* 2. 动态设置图片位置 */
/* 获取一列中最小高度，后续每张图片都是放在一列中最小高度的下面 */
/* 要传入子元素和每行可放置的图片个数 */
function getMinHeightOfCols(allChild,rowNum){
    /* 写一个数组，存储每列的高度 */
    var colsHeightArr = [];
    /* 遍历第一行rowNum张图片 */
    for(var i =0;i<allChild.length;i++){
        /* 判断取出第一行的图片，获取图片对应的高度，放入到数组中 */
        if(i < rowNum){
            /* 获取一行图片的高度,将其一一放入数组中*/
            colsHeightArr[i] = allChild[i].offsetHeight;
        }else{
            /* 获取列高度最小的值——找这个数组里面的最小值——用Math */
            var minHeightOfCols = Math.min.apply(null,colsHeightArr);
            /* 获取最小值对应的下标（位置） */
            var minHeightOfIndex = colsHeightArr.indexOf(minHeightOfCols);
            /* 摆放第二张图片的位置 */
            allChild[i].style.position = "absolute";
            allChild[i].style.top = minHeightOfCols + "px";
            allChild[i].style.left = allChild[minHeightOfIndex].offsetleft +"px";

            /* 高度的合并 */
            colsHeightArr[minHeightOfIndex] = colsHeightArr[minHeightOfIndex] + allChild[i].offsetHeight;
        }
    }
}
